"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var react_1 = __importStar(require("react"));
var RelIcon_1 = __importDefault(require("./../../components/RelIcon"));
var HelpButton_1 = __importDefault(require("./HelpButton"));
var RelButton_1 = __importDefault(require("./RelButton"));
var styles = function (theme) { return ({
    button: {
        margin: theme.spacing(1),
    },
}); };
var SlideUp = function (props) { return (react_1.default.createElement(core_1.Slide, __assign({ direction: 'up' }, props))); };
var isStandardRel = function (rel) { return rel.indexOf(':') === -1; };
exports.default = core_1.withStyles(styles)(/** @class */ (function (_super) {
    __extends(HyperMediaDialog, _super);
    function HyperMediaDialog() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            open: false,
        };
        _this._onOpen = function () {
            return _this.setState({
                open: true,
            });
        };
        _this._onClose = function () {
            return _this.setState({
                open: false,
            });
        };
        _this._onSubmit = function (e) {
            var onSubmit = _this.props.onSubmit;
            e.preventDefault();
            onSubmit();
            _this._onClose();
        };
        return _this;
    }
    HyperMediaDialog.prototype.render = function () {
        var _a = this.props, rel = _a.rel, title = _a.title, classes = _a.classes, children = _a.children, curies = _a.curies;
        var open = this.state.open;
        return (react_1.default.createElement("span", null,
            react_1.default.createElement(RelButton_1.default, { onClick: this._onOpen, className: classes.button, rel: rel, title: title }),
            react_1.default.createElement(core_1.Dialog, { open: open, TransitionComponent: SlideUp, disableBackdropClick: false, fullWidth: true, onEscapeKeyDown: this._onClose },
                react_1.default.createElement(core_1.DialogTitle, null, title),
                react_1.default.createElement(core_1.DialogContent, null, children),
                react_1.default.createElement(core_1.DialogActions, null,
                    !isStandardRel(rel) && (react_1.default.createElement(HelpButton_1.default, { rel: rel, curies: curies })),
                    react_1.default.createElement(core_1.Button, { onClick: this._onClose }, 'Cancel'),
                    react_1.default.createElement(core_1.Button, { variant: 'contained', color: 'primary', onClick: this._onSubmit },
                        react_1.default.createElement(RelIcon_1.default, { rel: rel, color: 'inherit' }),
                        'Submit')))));
    };
    return HyperMediaDialog;
}(react_1.PureComponent)));
